<?php

/**
 * Hooks
 *
 * @package 	PG_Core
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

if (!function_exists('check_browser_version')) {

    /**
     * Check browser version
     *
     * @package 	PG_Core
     * @subpackage 	Hooks
     *
     * @category	hooks
     *
     * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
     * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
     *
     * @return void
     */
    function check_browser_version()
    {
        if (!INSTALL_MODULE_DONE) {
            return;
        }
        $ci = &get_instance();
        $ci->load->library('user_agent');
        if (!$ci->agent->is_browser()) {
            return;
        }
        $ci->config->load('available_browsers', true);
        if ($ci->agent->version() < $ci->config->item($ci->agent->browser(), 'available_browsers')) {
            $ci->view->assign('display_browser_error', 1);
        }

        return;
    }
}
