<?php

/**
 * Hooks
 *
 * @package 	PG_Core
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

if (!function_exists('fetch_menu_indicators')) {
    /**
     * Load menu indicators
     *
     * @package 	PG_Core
     * @subpackage 	Hooks
     *
     * @category	hooks
     *
     * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
     * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
     *
     * @return void
     */
    function fetch_menu_indicators()
    {
        $CI = &get_instance();
        if (INSTALL_DONE) {
            if (!$CI->pg_module->get_module_config('menu', 'use_indicators') || !$CI->session->userdata('auth_type')) {
                return false;
            }
            $CI->load->model('Menu_model');
            $CI->load->model('menu/models/Indicators_model');
            $CI->Menu_model->indicators = $CI->Indicators_model->get(
            $CI->session->userdata('auth_type'),
            $CI->session->userdata('user_id'));
        }
    }
}
