function datePeriod() {

    this.day = function (optionArr) {
        var defaultDateFormat = 'yy-mm-dd';
        this.properties = {
            startDateInput: null,
            startDateAlt: null,
            endDateInput: null,
            endDateAlt: null,
            dateFormat: null
        };

        var _self = this;

        this.Init = function (options) {
            _self.properties = $.extend(_self.properties, options);
            if(!_self.properties.dateFormat) {
                console.error('Empty date format. Using default.');
                _self.properties.dateFormat = defaultDateFormat;
            }
            _self.initElements();
            _self.bindEvents();
        };

        this.initElements = function () {
            _self.properties.startDateInput.datepicker({
                dateFormat: _self.properties.dateFormat,
                altFormat: 'yy-mm-dd',
                altField: _self.properties.startDateAlt,
                showOn: 'both',
                minDate: 'now'
            }).next().addClass('fa fa-calendar').wrap('<span></span>');

            _self.properties.endDateInput.datepicker({
                dateFormat: _self.properties.dateFormat,
                altFormat: 'yy-mm-dd',
                altField: _self.properties.endDateAlt,
                showOn: 'both',
                minDate: 'now'
            }).next().addClass('fa fa-calendar').wrap('<span></span>');
        };

        _self.bindEvents = function () {
            _self.properties.startDateInput.bind('change', function () {
                var startDate = _self.properties.startDateInput.datepicker('getDate');
                var endDate = _self.properties.endDateInput.datepicker('getDate');
                if (null === endDate) {
                    endDate = startDate;                    
                    endDate.setDate(endDate.getDate());
                    _self.properties.endDateInput.datepicker('setDate', endDate);
                } else if (endDate < startDate) {
                    _self.properties.endDateInput.datepicker('setDate', startDate);
                }
            });
            _self.properties.endDateInput.bind('change', function () {
                var startDate = _self.properties.startDateInput.datepicker('getDate');
                var endDate = _self.properties.endDateInput.datepicker('getDate');
                if (null === startDate) {
                    startDate = endDate;
                    startDate.setDate(startDate.getDate());
                    _self.properties.startDateInput.datepicker('setDate', startDate);
                } else if (startDate > endDate) {
                    _self.properties.startDateInput.datepicker('setDate', endDate);
                }
            });
        };

        _self.Init(optionArr);
    };

    this.month = function (optionArr) {
        this.properties = {
            startMonthInput: null,
            startYearInput: null,
            endMonthInput: null,
            endYearInput: null
        };

        var _self = this;

        this.Init = function (options) {
            _self.properties = $.extend(_self.properties, options);
            _self.bindEvents();
        };

        this.checkMonth = function (input, val) {
            if (parseInt(_self.properties.startYearInput.val()) === parseInt(_self.properties.endYearInput.val())
                    && parseInt(_self.properties.startMonthInput.val()) > parseInt(_self.properties.endMonthInput.val())) {
                input.val(val);
            }
        };

        this.checkYear = function (input, val) {
            if (parseInt(_self.properties.startYearInput.val()) > parseInt(_self.properties.endYearInput.val())) {
                input.val(val);
            }
        };

        this.bindEvents = function () {
            _self.properties.startMonthInput.bind('change', function () {
                _self.checkMonth(_self.properties.endMonthInput, parseInt(_self.properties.startMonthInput.val()));
            });
            _self.properties.endMonthInput.bind('change', function () {
                _self.checkMonth(_self.properties.startMonthInput, parseInt(_self.properties.endMonthInput.val()));
            });
            _self.properties.startYearInput.bind('change', function () {
                _self.checkYear(_self.properties.endYearInput, parseInt(_self.properties.startYearInput.val()));
            });
            _self.properties.endYearInput.bind('change', function () {
                _self.checkYear(_self.properties.startYearInput, parseInt(_self.properties.endYearInput.val()));
            });
        };

        _self.Init(optionArr);
    };

}
