<?php

namespace Pg\Modules\Currencies\Controllers;

/**
 * Currencies module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Currencies user side controller
 *
 * @package 	PG_RealEstate
 * @subpackage 	Currencies
 *
 * @category	controllers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Currencies extends \Controller
{

    /**
     * Change currency
     *
     * @param integer $currency_id currency identifier
     *
     * @return void
     */
    public function change_currency($currency_id)
    {
        $currency_id = intval($currency_id);
        $this->session->set_userdata("currency_id", $currency_id);

        if (strpos($_SERVER["HTTP_REFERER"], site_url()) !== false) {
            $this->view->setRedirect($_SERVER["HTTP_REFERER"]);
        } else {
            $this->view->setRedirect();
        }
    }

}
