<?php

namespace Pg\Modules\Field_editor\Models;

/**
 * Field editor module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Field types loader Model
 *
 * @package 	PG_RealEstate
 * @subpackage 	Field editor
 *
 * @category	models
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Field_type_loader_model
{

    /**
     * Link to CodeIgniter object
     *
     * @var object
     */
    protected $ci;

    /**
     * Constructor
     *
     * @return Field_type_loader_model
     */
    public function __construct()
    {
        $this->ci = &get_instance();
    }

    /**
     * Return type object
     *
     * @param string $var type name
     *
     * @return object
     */
    public function __get($var)
    {
        if (!$var) {
            return '';
        }

        $driver_ns = NS_MODULES . 'Field_editor\\Models\\Fields\\' . ucfirst(strtolower($var)) . "_field_model";
        if (class_exists($driver_ns)) {
            $this->$var = new $driver_ns();
        } else {
            $this->$var = new Fields\Field_type_model();
        }
        return $this->$var;
    }

}
