DROP TABLE IF EXISTS `[prefix]import`;
CREATE TABLE IF NOT EXISTS `[prefix]import` (
  `id` smallint(5) NOT NULL auto_increment,
  `gid_driver` varchar(50) NOT NULL,
  `id_object` smallint(5) NOT NULL,
  `settings` text NULL,
  `relations` text NULL,
  `search_data` text NULL,
  `input_type` enum('upload', 'integration') NOT NULL,  
  `filename` varchar(255) NOT NULL,
  `scheduler` varchar(150) NOT NULL,
  `labels` text NULL,
  `position` int(3) NOT NULL,
  `total` int(3) NOT NULL,
  `processed` int(3) NOT NULL,
  `imported` int(3) NOT NULL,
  `failed` int(3) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `date_created` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `gid_driver` (`gid_driver`, `id_object`)  
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `[prefix]import_data`;
CREATE TABLE IF NOT EXISTS `[prefix]import_data` (
  `id` smallint(5) NOT NULL auto_increment,
  `id_import` varchar(50) NOT NULL,
  `data` mediumtext NULL,
  `errors` varchar(255) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `date_created` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `id_import` (`id_import`)  
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[prefix]import_drivers`;
CREATE TABLE IF NOT EXISTS `[prefix]import_drivers` (
  `id` tinyint(3) NOT NULL auto_increment,
  `gid` varchar(50) NOT NULL,
  `link` varchar(100) NOT NULL,
  `settings` mediumtext NULL,
  `elements` mediumtext NULL,
  `editable` tinyint(1) NOT NULL,
  `is_upload` tinyint NOT NULL,
  `is_integration` tinyint NOT NULL,
  `is_logging` tinyint(1) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `date_created` datetime NOT NULL,
  `date_modified` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `gid` (`gid`)  
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `[prefix]import_modules`;
CREATE TABLE IF NOT EXISTS `[prefix]import_modules` (
  `id` smallint(5) NOT NULL auto_increment,
  `module` varchar(50) NOT NULL,
  `model` varchar(50) NOT NULL,
  `callback_get_fields` varchar(50) NOT NULL,
  `callback_import_data` varchar(50) NOT NULL,
  `date_created` datetime NOT NULL,
  `date_modified` datetime NOT NULL,
  `sorter` tinyint(3) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
	
DROP TABLE IF EXISTS `[prefix]import_log`;
CREATE TABLE IF NOT EXISTS `[prefix]import_log` (
  `id` int(10) NOT NULL auto_increment,
  `id_import_data` int(10) NOT NULL,
  `gid_driver` varchar(50) NOT NULL,
  `id_object` smallint(5) NOT NULL,
  `system_id` varchar(50) NOT NULL,
  `site_id` int(10) NOT NULL,
  `date_created` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE `id_import_data` (`id_import_data`),
  KEY `system_id` (`gid_driver`, `id_object`, `system_id`)  
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
