<?php

use Pg\Modules\Language_identification\Models\Language_identification_model;

/**
 * Language_identification module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
/**
 * Language_identification helpers
 *
 * @package 	PG_RealEstate
 * @subpackage 	Language_identification
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!function_exists('admin_language_identification_settings')) {

    function admin_language_identification_settings($params = array())
    {
        $CI = &get_instance();
        $module_gid = Language_identification_model::MODULE_GID;

        $CI->view->assign('action', site_url() . "admin/" . $module_gid . "/ajax_settings");
        $CI->view->assign('automatic_identification', $CI->pg_module->get_module_config($module_gid, 'automatic_identification'));
        
        return $CI->view->fetch('helper_language_identification_settings', 'admin', $module_gid);
    }
}

if (!function_exists('user_language_identification')) {

    function user_language_identification($params = array())
    {
        $CI = &get_instance();
        $module_gid = Language_identification_model::MODULE_GID;
        $CI->view->assign('action', site_url() .  $module_gid);

        return $CI->view->fetch('helper_language_identification_user', 'user', $module_gid);
    }
}
