function fieldMultiselect(optionArr)
{
    this.properties = {
        fieldGid: '',
        fieldMultiselectId: '',
        multiselectStringInputId: '',
        btnCheckAllId: '',
        btnUncheckAllId: '',
        btnSaveValuesId: '',
        btnCancelValuesId: '',
        btnCheckClass: '',
        selectedOptionsString: ''
    };
    
    this.arrays = {        
        checkedInputsArrayMap: []
    };
    
    var _self = this;
    
    _self.Init = function(options) {
        _self.properties = $.extend(_self.properties, options);
        _self.bindEvents();
        
        $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid).prepend(
            '<div id="multiselect-cancel-' + _self.properties.fieldGid + '" class="fleft hide mltslt-mobile-show">' +
                '<label><i class="fa fa-times"></i>' +
                '</label>' +
            '</div>' +
            '<div id="multiselect-save-' + _self.properties.fieldGid + '" class="fright hide mltslt-mobile-show">' +
                '<label><i class="fa fa-check"></i>' +
                '</label>' +
            '</div>' +
            '<div id="multiselect-check-all-' + _self.properties.fieldGid + '" class="mltslct-check">' +
                '<label><i class="fa fa-plus-square-o"></i>' +
                    'Check all' +
                '</label>' +
            '</div>' +
            '<div id="multiselect-uncheck-all-' + _self.properties.fieldGid + '" class="mltslct-check">' +
                '<label><i class="fa fa-minus-square-o"></i>' +
                    'Uncheck all' +
                '</label>' +
            '</div>'
        );    
    };
    
    _self.bindEvents = function() {
        
        /*save values btn*/
        $('html').on('click', '#' + _self.properties.btnSaveValuesId + _self.properties.fieldGid, function(){
            $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid).hide();
            $('#' + _self.properties.multiselectStringInputId + _self.properties.fieldGid).css({
                'position': 'relative',
                'height':'30px',
                'width':'100%'
            });
            $('body').css({
                'overflow': 'scroll'
            });
        });
        
        /*cancel values btn*/
        $('html').on('click', '#' + _self.properties.btnCancelValuesId + _self.properties.fieldGid, function(){
            $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid + ' input').prop('checked', false);
            
            _self.properties.selectedOptionsString = '';
            
            for(var key in _self.arrays.checkedInputsArrayMap){
                $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid + ' input[value=' + key + ']').prop('checked', true);
                if(_self.properties.selectedOptionsString.length > 0) {
                    _self.properties.selectedOptionsString = _self.properties.selectedOptionsString + 
                    ', ' + 
                    $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid + ' input[value=' + key + ']').attr('value_string');
                }else{                        
                    _self.properties.selectedOptionsString = _self.properties.selectedOptionsString + 
                    $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid + ' input[value=' + key + ']').attr('value_string');
                }
            }
            _self.updateStringInput();
            
            $('#' + _self.properties.multiselectStringInputId + _self.properties.fieldGid).css({
                'position': 'relative',
                'height':'30px',
                'width':'100%'
            });
            $('body').css({
                'overflow': 'scroll'
            });
        });
        
        /*on check/uncheck checkbox*/        
        $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid + ' input').on('change', function(){  
             _self.updateSelectedOptionsString();
        });
        
        /*stop propagation on checkboxes click to prevent window closing*/
        $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid + ' .multiselect-checkbox-group').on('click', function(e){
            e.stopPropagation();
        });
        
        /*click on empty space (close window)*/
        $('html').on('click', function(){
            $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid).hide();
        });
        
        /*check all options button*/
        $('html').on('click', '#' + _self.properties.btnCheckAllId + _self.properties.fieldGid, function(e){
            e.stopPropagation();
            
            _self.updateSelectedOptionsString('check_all');
        });
        
        /*uncheck all options button*/
        $('html').on('click', '#' + _self.properties.btnUncheckAllId + _self.properties.fieldGid, function(e){
            e.stopPropagation();
            $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid + ' input').each(function(){
                $(this).prop('checked', false);
            });
            $('#' + _self.properties.multiselectStringInputId + _self.properties.fieldGid).val('');
        });
        
        /*clickable input text field*/
        $('#' + _self.properties.multiselectStringInputId + _self.properties.fieldGid).on('click', function(e){
            e.stopPropagation();
            $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid).toggle();
            if($(window).width() < 767) {
                $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid + ' input').each(function(){                    
                    if($(this).prop('checked') == true)
                        _self.arrays.checkedInputsArrayMap[$(this).val()] = '1';
                });
                $('body').css({
                    'overflow': 'hidden',
                    'height': '100%'
                });
                $('#' + _self.properties.multiselectStringInputId + _self.properties.fieldGid).css({
                    'position': 'fixed',
                    'top': '0',
                    'left': '0',
                    'height':'10%',
                    'width':'100%'
                });
            }
        });  
        
    };
    
    _self.updateStringInput = function() {
        $('#' + _self.properties.multiselectStringInputId + 
            _self.properties.fieldGid).val(_self.properties.selectedOptionsString);
    };
    
    _self.updateSelectedOptionsString = function(flag) {
        _self.properties.selectedOptionsString = '';
        $('#' + _self.properties.fieldMultiselectId + _self.properties.fieldGid + ' input').each(function(){                
            if(flag === 'check_all') {
                $(this).prop('checked', true);
            }
            
            if($(this).prop('checked') == true) {
                if(_self.properties.selectedOptionsString.length > 0) {
                    _self.properties.selectedOptionsString = _self.properties.selectedOptionsString + 
                    ', ' + $(this).attr('value_string');
                }else{                        
                    _self.properties.selectedOptionsString = _self.properties.selectedOptionsString + 
                    $(this).attr('value_string');
                }
            }
        });
        _self.updateStringInput();
    };
    
    _self.Init(optionArr);
}