<?php

namespace Pg\Modules\Listings\Models;

/**
 * Listings module
 *
 * @package 	PG_RealEstate
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Listings Form Model
 * 
 * @package 	PG_RealEstate
 * @subpackage 	Listings
 * @category	models
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Listings_form_model extends \Model
{

    /**
     * Link to CodeIgniter object
     * 
     * @var object
     */
    protected $CI;

    /**
     * Main search form from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_gid = 'main_search_form';

    /**
     * Main search form of Residential category (for sale) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_residential_sale_gid = 'main_search_form_1';

    /**
     * Main search form of Commercial category (for sale) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_commercial_sale_gid = 'main_search_form_2';

    /**
     * Main search form of Lot and land category (for sale) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_lot_and_land_sale_gid = 'main_search_form_3';

    /**
     * Main search form of Residential category (for buy) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_residential_buy_gid = 'main_search_form_7';

    /**
     * Main search form of Commercial category (for buy) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_commercial_buy_gid = 'main_search_form_8';

    /**
     * Main search form of Lot and land category (for buy) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_lot_and_land_buy_gid = 'main_search_form_9';

    /**
     * Main search form of Residential category (for rent) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_residential_rent_gid = 'main_search_form_4';

    /**
     * Main search form of Commercial category (for rent) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_commercial_rent_gid = 'main_search_form_5';

    /**
     * Main search form of Lot and land category (for rent) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_lot_and_land_rent_gid = 'main_search_form_6';

    /**
     * Main search form of Residential category (for lease) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_residential_lease_gid = 'main_search_form_10';

    /**
     * Main search form of Commercial category (for lease) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_commercial_lease_gid = 'main_search_form_11';

    /**
     * Main search form of Lot and land category (for lease) from field editor (GUID)
     * 
     * @var string
     */
    public $main_search_form_lot_and_land_lease_gid = 'main_search_form_12';

    /**
     * Quick search form from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_gid = 'quick_search_form';

    /**
     * Quick search form of Residential category (for sale) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_residential_sale_gid = 'quick_search_form_1';

    /**
     * Quick search form of Commercial category (for sale) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_commercial_sale_gid = 'quick_search_form_2';

    /**
     * Quick search form of Lot and land category (for sale) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_lot_and_land_sale_gid = 'quick_search_form_3';

    /**
     * Quick search form of Residential category (for buy) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_residential_buy_gid = 'quick_search_form_7';

    /**
     * Quick search form of Commercial category (for buy) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_commercial_buy_gid = 'quick_search_form_8';

    /**
     * Quick search form of Lot and land category (for buy) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_lot_and_land_buy_gid = 'quick_search_form_9';

    /**
     * Quick search form of Residential category (for rent) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_residential_rent_gid = 'quick_search_form_4';

    /**
     * Quick search form of Commercial category (for rent) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_commercial_rent_gid = 'quick_search_form_5';

    /**
     * Quick search form of Lot and land category (for rent) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_lot_and_land_rent_gid = 'quick_search_form_6';

    /**
     * Quick search form of Residential category (for lease) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_residential_lease_gid = 'quick_search_form_10';

    /**
     * Quick search form of Commercial category (for lease) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_commercial_lease_gid = 'quick_search_form_11';

    /**
     * Quick search form of Lot and land category (for lease) from field editor (GUID)
     * 
     * @var string
     */
    public $quick_search_form_lot_and_land_lease_gid = 'quick_search_form_12';

    /**
     * Advanced search form from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_gid = 'advanced_search_form';

    /**
     * Advanced search form of Residential category (for sale) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_residential_sale_gid = 'advanced_search_1';

    /**
     * Advanced search form of Commercial category (for sale) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_commercial_sale_gid = 'advanced_search_2';

    /**
     * Advanced search form of Lot and land category (for sale) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_lot_and_land_sale_gid = 'advanced_search_3';

    /**
     * Advanced search form of Residential category (for buy) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_residential_buy_gid = 'advanced_search_7';

    /**
     * Advanced search form of Commercial category (for buy) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_commercial_buy_gid = 'advanced_search_8';

    /**
     * Advanced search form of Lot and land category (for buy) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_lot_and_land_buy_gid = 'advanced_search_9';

    /**
     * Advanced search form of Residential category (for rent) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_residential_rent_gid = 'advanced_search_4';

    /**
     * Advanced search form of Commercial category (for rent) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_commercial_rent_gid = 'advanced_search_5';

    /**
     * Advanced search form of Lot and land (for rent) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_lot_and_land_rent_gid = 'advanced_search_6';

    /**
     * Advanced search form of Residential category (for lease) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_residential_lease_gid = 'advanced_search_10';

    /**
     * Advanced search form of Commercial category (for lease) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_commercial_lease_gid = 'advanced_search_11';

    /**
     * Advanced search form of Lot and land category (for lease) from field editor (GUID)
     * 
     * @var string
     */
    public $advanced_search_form_lot_and_land_lease_gid = 'advanced_search_12';

    /**
     * Constructor
     *
     * return Listings_form_model
     */
    public function __construct()
    {
        parent::__construct();
        $this->CI = & get_instance();
    }

    /**
     * Return form fields from field editor
     * 
     * @param string $property_type_gid property type guid
     * @param string $form_gid form GUID
     * @param boolean $admin_mode admin mode
     * @return array
     */
    public function get_search_extend_form($property_type_gid, $form_gid, $admin_mode = true)
    {
        $this->CI->load->model('Field_editor_model');
        $this->CI->Field_editor_model->initialize($property_type_gid);
        $form_gid = $this->{$this->{$form_gid} . '_' . $property_type_gid . '_gid'};
        $this->CI->load->model('field_editor/models/Field_editor_forms_model');
        $form = $this->CI->Field_editor_forms_model->get_form_by_gid($form_gid, $property_type_gid);
        $form = $this->CI->Field_editor_forms_model->format_output_form($form);
        return $form['field_data'];
    }

}
