<?php

return [
    'menu' => [
        "admin_listings_menu" => [
            "action" => "none",
            "name" => "Admin mode - Listings booking",
            "items" => [
                "listings-booking-item" => ["action" => "create", "link" => "admin/listings_booking/orders", "status" => 1, "sorter" => 3],
            ],
        ],
        "private_top_menu" => [
            "action" => "none",
            "items" => [
                "private-main-my-booking-item" => ["action" => "create", "link" => "listings_booking/orders", "status" => 1, "sorter" => 4],
            ],
        ],
        "company_top_menu" => [
            "action" => "none",
            "items" => [
                "company-main-my-booking-item" => ["action" => "create", "link" => "listings_booking/orders", "status" => 1, "sorter" => 4],
            ],
        ],
        "agent_top_menu" => [
            "action" => "none",
            "items" => [
                "agent-main-my-booking-item" => ["action" => "create", "link" => "listings_booking/orders", "status" => 1, "sorter" => 4],
            ],
        ],
        "private_account_menu" => [
            "action" => "none",
            "items" => [
                "private_my_booking_item" => [
                    "action" => "create",
                    "link" => "listings_booking/orders",
                    "status" => 1,
                    "sorter" => 4,
                    "items" => [
                        "private_my_orders_item" => ["action" => "create", "link" => "listings_booking/orders", "status" => 1, "sorter" => 1, 'indicator_gid' => 'new_booking_item'],
                        "private_my_requests_item" => ["action" => "create", "link" => "listings_booking/requests", "status" => 1, "sorter" => 2, 'indicator_gid' => 'booking_status_item'],
                    ],
                    'indicator_gid' => 'all_booking_item',
                ],
            ],
        ],
        "company_account_menu" => [
            "action" => "none",
            "items" => [
                "company_my_booking_item" => [
                    "action" => "create",
                    "link" => "listings_booking/orders",
                    "status" => 1,
                    "sorter" => 4,
                    "items" => [
                        "company_my_orders_item" => ["action" => "create", "link" => "listings_booking/orders", "status" => 1, "sorter" => 1, 'indicator_gid' => 'new_booking_item'],
                        "company_my_requests_item" => ["action" => "create", "link" => "listings_booking/requests", "status" => 1, "sorter" => 2, 'indicator_gid' => 'booking_status_item'],
                    ],
                    'indicator_gid' => 'all_booking_item',
                ],
            ],
        ],
        "agent_account_menu" => [
            "action" => "none",
            "items" => [
                "agent_my_booking_item" => [
                    "action" => "create",
                    "link" => "listings_booking/orders",
                    "status" => 1,
                    "sorter" => 4,
                    "items" => [
                        "agent_my_orders_item" => ["action" => "create", "link" => "listings_booking/orders", "status" => 1, "sorter" => 1, 'indicator_gid' => 'new_booking_item'],
                        "agent_my_requests_item" => ["action" => "create", "link" => "listings_booking/requests", "status" => 1, "sorter" => 2, 'indicator_gid' => 'booking_status_item'],
                    ],
                    'indicator_gid' => 'all_booking_item',
                ],
            ],
        ],
        "private_slide_profile_menu" => [
            "action" => "none",
            "items" => [
                "private_my_booking_item" => [
                    "action" => "create",
                    "link" => "listings_booking/orders",
                    "status" => 1,
                    "sorter" => 3,
                    "items" => [
                        "private_my_orders_item" => ["action" => "create", "link" => "listings_booking/orders", "status" => 1, "sorter" => 1, 'indicator_gid' => 'new_booking_item'],
                        "private_my_requests_item" => ["action" => "create", "link" => "listings_booking/requests", "status" => 1, "sorter" => 2, 'indicator_gid' => 'booking_status_item'],
                    ],
                    'indicator_gid' => 'all_booking_item',
                ],
            ],
        ],
        "company_slide_profile_menu" => [
            "action" => "none",
            "items" => [
                "company_my_booking_item" => [
                    "action" => "create",
                    "link" => "listings_booking/orders",
                    "status" => 1,
                    "sorter" => 3,
                    "items" => [
                        "company_my_orders_item" => ["action" => "create", "link" => "listings_booking/orders", "status" => 1, "sorter" => 1, 'indicator_gid' => 'new_booking_item'],
                        "company_my_requests_item" => ["action" => "create", "link" => "listings_booking/requests", "status" => 1, "sorter" => 2, 'indicator_gid' => 'booking_status_item'],
                    ],
                    'indicator_gid' => 'all_booking_item',
                ],
            ],
        ],
        "agent_slide_profile_menu" => [
            "action" => "none",
            "items" => [
                "agent_my_booking_item" => [
                    "action" => "create",
                    "link" => "listings_booking/orders",
                    "status" => 1,
                    "sorter" => 3,
                    "items" => [
                        "agent_my_orders_item" => ["action" => "create", "link" => "listings_booking/orders", "status" => 1, "sorter" => 1, 'indicator_gid' => 'new_booking_item'],
                        "agent_my_requests_item" => ["action" => "create", "link" => "listings_booking/requests", "status" => 1, "sorter" => 2, 'indicator_gid' => 'booking_status_item'],
                    ],
                    'indicator_gid' => 'all_booking_item',
                ],
            ],
        ],
    ],
    'menu_indicators' => [
        [
            'gid' => 'new_booking_item',
            'delete_by_cron' => false,
            'auth_type' => 'user',
        ],
    ],
    'notifications' => [
        "templates" => [
            ["gid" => "listing_booking_request", "name" => "New booking request", "vars" => ['user', 'name', 'fname', 'sname'], "content_type" => "text"],
            ["gid" => "admin_booking_request", "name" => "New booking request (for_admin)", "vars" => ['user', 'name', 'owner'], "content_type" => "text"],
            ["gid" => "listing_booking_approve", "name" => "Approve booking request", "vars" => ['user', 'name', 'fname', 'sname'], "content_type" => "text"],
            ["gid" => "admin_booking_approve", "name" => "Approve booking request (for admin)", "vars" => ['user', 'name', 'owner'], "content_type" => "text"],
            ["gid" => "listing_booking_decline", "name" => "Decline booking request", "vars" => ['user', 'name', 'fname', 'sname'], "content_type" => "text"],
            ["gid" => "admin_booking_decline", "name" => "Decline booking request (for admin)", "vars" => ['user', 'name', 'owner'], "content_type" => "text"],
            ["gid" => "guest_booking_request", "name" => "New booking request from guest", "vars" => ['fname', 'sname', 'confirmation_link'], "content_type" => "text"],
            ["gid" => "guest_booking_approve", "name" => "Approve booking request", "vars" => ['content'], "content_type" => "html"],
            ["gid" => "guest_booking_decline", "name" => "Decline booking request", "vars" => ['fname', 'sname', 'decline_reason', 'user', 'name'], "content_type" => "html"],
            ["gid" => "guest_booking_blacklisted", "name" => "Email blacklisted", "vars" => ['listing_owner', 'listing_name'], "content_type" => "text"],
        ],
        "notifications" => [
            ["gid" => "listing_booking_request", "template" => "listing_booking_request", "send_type" => "simple"],
            ["gid" => "admin_booking_request", "template" => "admin_booking_request", "send_type" => "simple"],
            ["gid" => "listing_booking_approve", "template" => "listing_booking_approve", "send_type" => "simple"],
            ["gid" => "admin_booking_approve", "template" => "admin_booking_approve", "send_type" => "simple"],
            ["gid" => "listing_booking_decline", "template" => "listing_booking_decline", "send_type" => "simple"],
            ["gid" => "admin_booking_decline", "template" => "admin_booking_decline", "send_type" => "simple"],
            ["gid" => "guest_booking_request", "template" => "guest_booking_request", "send_type" => "simple"],
            ["gid" => "guest_booking_approve", "template" => "guest_booking_approve", "send_type" => "simple"],
            ["gid" => "guest_booking_decline", "template" => "guest_booking_decline", "send_type" => "simple"],
            ["gid" => "guest_booking_blacklisted", "template" => "guest_booking_blacklisted", "send_type" => "simple"],
        ],
    ],
    'cronjobs' => [
        [
            "name" => "Search booking cache clean",
            "module" => "listings_booking",
            "model" => "Listings_booking_model",
            "method" => "search_booking_cron",
            "cron_tab" => "0 * * * *",
            "status" => "1",
        ],
    ],
];
