function listingsGuestEditBooking(optionArr) 
{
    this.properties = {
        siteUrl: '',
        editBtnId: '',
        saveBtnId: '',
        cancelEditBtnClass: '',
        cancelBookingBtnId: '',
        formId: '',
        bookingErrorObj: {},
        
        periodId: '',
        periodConfirmationCode: '',
        
        formData: {},
        
        langs: {
            book: '',
            wait: '',
            decline: '',
        },
    }
    
    var _self = this;
    
    this.Init = function(options) {
        _self.properties = $.extend(_self.properties, options);
        _self.initButtons();
    }
    
    this.initButtons = function() {
        $('#' + _self.properties.editBtnId).bind('click', function(){
            _self.showForm();
        });
        $('#' + _self.properties.saveBtnId).bind('click', function(){
            _self.properties.formData = $('#' + _self.properties.formId).serialize();
            _self.sendForm();
        });
        $('#' + _self.properties.cancelBookingBtnId).bind('click', function(){
            _self.cancelBooking();
        });
        $('.' + _self.properties.cancelEditBtnClass).bind('click', function(){
            _self.hideForm();
        });
    }
    
    this.showForm = function() {
        $('.field-to-edit').hide();
        $('.gb-edit-field').show();        
    }
    
    this.hideForm = function() {
        $('.field-to-edit').show();
        $('.gb-edit-field').hide();        
    }
    
    this.showModerationAlert = function (alertType) {
        var moderation_alert = $('#gb_moderation_alert');
        $('#gb_moderation_alert span').html(_self.properties.langs[alertType]);
        
        switch(alertType) {
            case 'book': 
                moderation_alert.removeClass().addClass('alert alert-success');
                break;
            default: 
                moderation_alert.removeClass().addClass('alert alert-info');
                break;
        }
    }
    
    this.sendForm = function() {
        $.ajax({
            url: _self.properties.siteUrl + 'listings_booking/guest_order_view/' + 
                +_self.properties.periodId + '/' + _self.properties.periodConfirmationCode,
            method: 'post',
            data: _self.properties.formData,
            dataType: 'json',
            success: function (data) {
                if(data.success) {
                    for (var key in data.success) {
                        $('[for=' + key + ']').html(data.success[key]);
                    }
                    _self.showForm();
                    _self.showModerationAlert('wait');
                    _self.properties.bookingErrorObj.show_error_block('Изменения сохранены, запрос отправлен на модерацию', 'success');
                } else if(data.error) {
                    _self.properties.bookingErrorObj.show_error_block(data.error, 'error');
                } else if(data.no_data_change) {
                    _self.hideForm();
                }
            }
        });
    }
    
    this.cancelBooking = function() {
        var cancel_booking = confirm('Вы действительно хотите отменить бронь?');
        if (cancel_booking == true) {
            document.location.href = _self.properties.siteUrl + 'listings_booking/guest_cancel_booking/' + 
                + _self.properties.periodId + '/' + 
                + _self.properties.periodConfirmationCode;
        }
    }
    
    _self.Init(optionArr);
}