DROP TABLE IF EXISTS `[prefix]news`;
CREATE TABLE IF NOT EXISTS `[prefix]news` (
  `id` int(3) NOT NULL AUTO_INCREMENT,
  `gid` varchar(100) NOT NULL,
  `img` varchar(255) NOT NULL,
  `status` tinyint(3) NOT NULL,
  `id_lang` tinyint(3) NOT NULL,
  `news_type` enum('news','feed') NOT NULL,
  `date_add` datetime NOT NULL,
  `feed_link` varchar(255) NOT NULL,
  `feed_id` int(3) NOT NULL,
  `feed_unique_id` varchar(50) NOT NULL,
  `video` varchar(255) NOT NULL,
  `video_image` varchar(255) NOT NULL,
  `video_data` text NOT NULL,
  `set_to_subscribe` tinyint(3) NOT NULL DEFAULT '0',
  `id_seo_settings` int(3) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `gid` (`gid`),
  KEY `id_lang` (`id_lang`),
  KEY `feed_unique_id` (`feed_unique_id`),
  KEY `date_add` (`date_add`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `[prefix]news_feeds`;
CREATE TABLE IF NOT EXISTS `[prefix]news_feeds` (
  `id` int(3) NOT NULL AUTO_INCREMENT,
  `link` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` varchar(255) NOT NULL,
  `site_link` varchar(255) NOT NULL,
  `encoding` varchar(10) NOT NULL,
  `status` tinyint(4) NOT NULL,
  `id_lang` int(11) NOT NULL,
  `max_news` tinyint(4) NOT NULL,
  `date_add` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `status` (`status`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `[prefix]news_events`;
CREATE TABLE IF NOT EXISTS `[prefix]news_events` (
  `id` int(3) NOT NULL auto_increment,
  `module` varchar(20) NOT NULL,
  `model` varchar(50) NOT NULL,
  `save_callback` varchar(255) NOT NULL,
  `delete_callback` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `module` (`module`),
  UNIQUE `model` (`module`, `model`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT INTO `[prefix]news_feeds` VALUES(NULL, 'http://blog.pilotgroup.net/category/pg-real-estate/feed/', 'Blog pilotgroup.net - Real Estate', 'Industry news, company news, updates, inspiration', 'http://blog.pilotgroup.net/category/pg-real-estate/', 'UTF-8', 1, 1, 10, '2012-07-16 10:05:48');
