<?php

$module['module'] = 'payments';
$module['install_name'] = 'Payments';
$module['install_descr'] = 'Payments settings';
$module['version'] = '5.03';
$module['files'] = array(
    array('file', 'read', "application/modules/payments/controllers/admin_payments.php"),
    array('file', 'read', "application/modules/payments/controllers/api_payments.php"),
    array('file', 'read', "application/modules/payments/controllers/payments.php"),
    array('file', 'read', "application/modules/payments/helpers/payments_helper.php"),
    array('file', 'read', "application/modules/payments/install/module.php"),
    array('file', 'read', "application/modules/payments/install/permissions.php"),
    array('file', 'read', "application/modules/payments/install/settings.php"),
    array('file', 'read', "application/modules/payments/install/structure_deinstall.sql"),
    array('file', 'read', "application/modules/payments/install/structure_install.sql"),
    array('file', 'read', "application/modules/payments/js/payment-system-tarifs.js"),
    array('file', 'read', "application/modules/payments/models/systems/authorize_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/barclays_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/chronopay_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/daopay_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/egold_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/fortumo_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/gwallet_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/manual_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/offline_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/ogone_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/paygol_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/paypal_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/paypoint_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/pencepay_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/robokassa_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/skrill_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/smscoin_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/stripe_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/tcheckout_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/usaepay_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/webmoney_model.php"),
    array('file', 'read', "application/modules/payments/models/systems/worldpay_model.php"),
    array('file', 'read', "application/modules/payments/models/payment_driver_model.php"),
    array('file', 'read', "application/modules/payments/models/payment_systems_model.php"),
    array('file', 'read', "application/modules/payments/models/payments_install_model.php"),
    array('file', 'read', "application/modules/payments/models/payments_model.php"),
    array('dir', 'read', 'application/modules/payments/langs'),
);

$module['libraries'] = array(
    'jwt',
    'simple_html_dom',
    'Stripe_api',
    'mobile_detect',
);

$module['dependencies'] = array(
    'start'           => array('version' => '1.01'),
    'menu'            => array('version' => '3.01'),
    'users'           => array('version' => '1.01'),
    'notifications'   => array('version' => '1.03'),
    'currencies'      => array('version' => '1.01'),
);

$module['linked_modules'] = array(
    'install' => array(
        'menu'              => 'install_menu',
        'moderators'        => 'install_moderators',
        'cronjob'           => 'install_cronjob',
        'notifications'     => 'install_notifications',
    ),
    'deinstall' => array(
        'menu'              => 'deinstall_menu',
        'moderators'        => 'deinstall_moderators',
        'cronjob'           => 'deinstall_cronjob',
        'notifications'     => 'deinstall_notifications',
    ),
);
