<?php

namespace Pg\Modules\Social_networking\Models\Widgets;

/**
 * Social networking module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

/**
 * Social networking linkdin widget model
 *
 * @package 	PG_RealEstate
 * @subpackage 	Social networking
 *
 * @category	models
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Linkedin_widgets_model extends \Model
{

    /**
     * Link to CodeIgniter object
     *
     * @var object
     */
    protected $ci;

    /**
     * Available widgets
     *
     * @var array
     */
    public $widget_types = array(
        'share',
    );

    /**
     * Page header data is loaded
     *
     * @var boolean
     */
    public $head_loaded = false;

    /**
     * Class constructor
     *
     * @return Linkedin_widgets_model
     */
    public function __construct()
    {
        parent::__construct();
        $this->ci = &get_instance();
    }

    /**
     * Return widgets data for page header
     *
     * @param array  $service_data service data
     * @param string $locale       locale code
     * @param array  $types        widget types
     *
     * @return string
     */
    public function get_header($service_data = array(), $locale = '', $types = array())
    {
        $header = '';
        if (in_array('share', $types)) {
            $header .= '<script src="//platform.linkedin.com/in.js" type="text/javascript"></script>';
        }
        $this->head_loaded = $header ? true : false;

        return $header;
    }

    /**
     * Return code of 'Share' widget
     *
     * @return string
     */
    public function get_share()
    {
        return $this->head_loaded ? '<script type="IN/Share" data-counter="right"></script>' : '';
    }

}
