function userSearch(optionArr){
    this.properties = {
        siteUrl: '',
        viewAjaxUrl: 'users/ajax_search',
        loadQuickForm: 'users/ajax_get_search_quick_form/',
        saveSearchUrl: '',
        sFromId: 'search_users_form',
        sectionId: 'search_users_sections',
        listBlockId: 'users_block',
        mapBlockId: 'users_map',
        quickFormId: 'quick_search_extend_form',
        errorObj: new Errors(),
    };

    var _self = this;

    this.Init = function(options){
        _self.properties = $.extend(_self.properties, options);

        var sFormId = $('#'+_self.properties.sFromId);

        sFormId.find('select[name=user_type]').bind('change', function(){
            _self.load_extend_form($(this).val());
        });

        sFormId.bind('submit', function(){
            _self.search();
            return false;
        });
    }

    this.search = function(){
        var user_type = $('#'+_self.properties.sFromId+' select:first').val();
        $('#'+_self.properties.sectionId+' li').removeClass('active');
        $('#'+_self.properties.sectionId+' li[sgid='+user_type+']').addClass('active');
        var send_data = $('#'+_self.properties.sFromId).serialize();
        $.ajax({
            url: _self.properties.siteUrl + _self.properties.viewAjaxUrl,
            type: 'POST',
            cache: false,
            data: send_data,
            success: function(data) {
                $('#'+_self.properties.sectionId).trigger('change');

                var top = $('#'+_self.properties.listBlockId).offset().top;
                $(document).scrollTop(top);
            }
        });
    }

    this.save_search = function(){
        $.ajax({
            url: _self.properties.siteUrl + _self.properties.saveSearchUrl,
            type: 'GET',
            cache: false,
            dataType: 'json',
            success: function(data){
                if(data.success){
                    _self.properties.errorObj.show_error_block(data.success, 'success');
                }else{
                    _self.properties.errorObj.show_error_block(data.error, 'error');
                }
                return false;
            }
        });
    }

    this.load_extend_form = function(user_type){
        $.ajax({
            url: _self.properties.siteUrl + _self.properties.loadQuickForm,
            type: 'POST',
            cache: false,
            data: {user_type: user_type},
            dataType: 'html',
            success: function(data){
                $('#'+_self.properties.quickFormId+' .ui-slider').empty();
                $('#'+_self.properties.quickFormId).html(data);
            }
        });
    }

    _self.Init(optionArr);
}
