<?php

/**
 * Users connections module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Users connections management
 *
 * @package 	PG_RealEstate
 * @subpackage 	Users connections
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

if (!function_exists('show_social_networking_link')) {
    /**
     * Display connected links to social services
     *
     * @return string
     */
    function show_social_networking_link()
    {
        $ci = &get_instance();
        $user_id = $ci->session->userdata('user_id');
        
        $ci->load->model('social_networking/models/Social_networking_services_model');
        $ci->load->model('Users_connections_model');
        
        $services = $ci->Social_networking_services_model
                ->get_services_list(null, array('where' => array('oauth_status' => 1)));
        
        if (count($services) == 0) {
            return false;
        }
        
        $apps = array();
        $unapps = array();
        foreach ($services as $id => $val) {
            $connection = $ci->Users_connections_model->get_connection_by_user_id($val['id'], $user_id);
            if ($connection && isset($connection['id'])) {
                $unapps[$id] = $val;
            } else {
                $apps[$id] = $val;
            }
        }
        
        $ci->view->assign("applications", $apps);
        $ci->view->assign("un_applications", $unapps);
        $ci->view->assign("site_url", site_url());
        $ci->view->output($ci->view->fetch("oauth_link", 'user', 'users_connections'));
        
        $ci->view->render();
    }
}

if (!function_exists('show_social_networking_login')) {
    /**
     * Return authorized links to social services
     *
     * @return string
     */
    function show_social_networking_login()
    {
        //$domain = $_SERVER['SERVER_NAME'];
        $ci = &get_instance();
        $ci->load->model('social_networking/models/Social_networking_services_model');
        $services = $ci->Social_networking_services_model
                ->get_services_list(null, array('where' => array('oauth_status' => 1)));
        $ci->view->assign("services", $services);
        $ci->view->assign("site_url", site_url());

        return $ci->view->fetch('oauth_login', 'user', 'users_connections');
    }
}
