<?php

return [
    'menu' => [
        'private_account_menu' => [
            'action' => 'none',
            'name' => '',
            'items' => [
                'private_payments_item' => [
                    'action' => 'none',
                    'items' => [
                        'private_my_services_item' => ['action' => 'create', 'link' => 'users_services/my_services', 'status' => 1, 'sorter' => 1],
                    ],
                ],
            ],
        ],
        'company_account_menu' => [
            'action' => 'none',
            'name' => '',
            'items' => [
                'company_payments_item' => [
                    'action' => 'none',
                    'items' => [
                        'company_my_services_item' => ['action' => 'create', 'link' => 'users_services/my_services', 'status' => 1, 'sorter' => 1],
                    ],
                ],
            ],
        ],
        'agent_account_menu' => [
            'action' => 'none',
            'name' => '',
            'items' => [
                'agent_payments_item' => [
                    'action' => 'none',
                    'items' => [
                        'agent_my_services_item' => ['action' => 'create', 'link' => 'users_services/my_services', 'status' => 1, 'sorter' => 1],
                    ],
                ],
            ],
        ],
    ],
    'services' => [
        'templates' => [
            //contact service
            [
                'gid' => 'contact_template',
                'callback_module' => 'users_services',
                'callback_model' => 'Users_services_model',
                'callback_buy_method' => 'service_contact_buy',
                'callback_activate_method' => 'service_contact_activate',
                'callback_validate_method' => 'service_contact_validate',
                'price_type' => 1,
                'data_admin' => ['contact_count' => 'int', 'service_period' => 'int'],
                'data_user' => [],
                'is_membership' => 1,
                'data_membership' => ['contact_count' => 'int'],
                'data_membership_service' => ['contact_count' => '0'],
                'moveable' => 1,
            ],
            //post service
            [
                'gid' => 'listings_post_template',
                'callback_module' => 'users_services',
                'callback_model' => 'Users_services_model',
                'callback_buy_method' => 'service_post_buy',
                'callback_activate_method' => 'service_post_activate',
                'callback_validate_method' => 'service_post_validate',
                'price_type' => 1,
                'data_admin' => ['post_count' => 'int', 'period' => 'int'],
                'data_user' => [],
                'is_membership' => 1,
                'data_membership' => ['post_count' => 'int'],
                'data_membership_service' => ['post_count' => '0'],
                'moveable' => 1,
            ],
            //combined service
            /*[
                'gid' => 'combined_template',
                'callback_module' => 'users_services',
                'callback_model' => 'Users_services_model',
                'callback_buy_method' => 'service_combined_buy',
                'callback_activate_method' => 'service_combined_activate',
                'callback_validate_method' => 'service_combined_validate',
                'price_type' => 1,
                'data_admin' => ['contact_count' => 'int', 'service_period' => 'int', 'post_count' => 'int', 'period' => 'int'],
                'data_user' => [],
                'is_membership' => 0,
                'data_membership' => ['contact_count' => 'int', 'post_count' => 'int'],
                'data_membership_service' => ['contact_count' => '0', 'post_count' => '0'],
                'moveable' => 1,
            ],*/
            //featured service
            [
                'gid' => 'featured_template',
                'callback_module' => 'users_services',
                'callback_model' => 'Users_services_model',
                'callback_buy_method' => 'service_featured_buy',
                'callback_activate_method' => 'service_featured_activate',
                'callback_validate_method' => 'service_featured_validate',
                'price_type' => 1,
                'data_admin' => ['period' => 'int'],
                'data_user' => ['user' => 'hidden'],
                'is_membership' => 1,
                'data_membership' => [],
                'moveable' => 1,
            ],
            // show logo service
            [
                'gid' => 'show_logo_template',
                'callback_module' => 'users_services',
                'callback_model' => 'Users_services_model',
                'callback_buy_method' => 'service_show_logo_buy',
                'callback_activate_method' => 'service_show_logo_activate',
                'callback_validate_method' => 'service_show_logo_validate',
                'price_type' => 1,
                'data_admin' => ['period' => 'int'],
                'data_user' => ['user' => 'hidden'],
                'is_membership' => 1,
                'data_membership' => [],
                'moveable' => 1,
            ],
        ],
        'services' => [
            // contact service
            [
                'gid' => 'contact_service',
                'template_gid' => 'contact_template',
                'type' => 'tariff',
                'pay_type' => 2,
                'status' => 0,
                'price' => 1,
                'data_admin' => ['contact_count' => 10, 'service_period' => 1],
            ],
            // post service
            [
                'gid' => 'listings_post_service',
                'template_gid' => 'listings_post_template',
                'type' => 'tariff',
                'pay_type' => 2,
                'status' => 1,
                'price' => 1,
                'data_admin' => ['post_count' => 10, 'period' => 1],
            ],
            // combined service
            /*[
                'gid' => 'combined_service',
                'template_gid' => 'combined_template',
                'type' => 'tariff',
                'pay_type' => 2,
                'status' => 0,
                'price' => 1,
                'data_admin' => ['contact_count' => 10, 'service_period' => 1, 'post_count' => 10, 'period' => 1],
            ],*/
            // featured service
            [
                'gid' => 'featured_services',
                'template_gid' => 'featured_template',
                'type' => 'tariff',
                'pay_type' => 2,
                'status' => 1,
                'price' => 10,
                'data_admin' => ['period' => '30'],
            ],
            // show logo service
            [
                'gid' => 'show_logo_services',
                'template_gid' => 'show_logo_template',
                'type' => 'tariff',
                'pay_type' => 2,
                'status' => 1,
                'price' => 10,
                'data_admin' => ['period' => '30'],
            ],
        ],
    ],
    'notifications' => [
        'templates' => [
            ['gid' => 'user_package_enabled', 'name' => 'Users paid service (package) enabled', 'vars' => ['user', 'name'], 'content_type' => 'text'],
            ['gid' => 'user_service_enabled', 'name' => 'Users paid service enabled', 'vars' => ['user', 'name', 'date'], 'content_type' => 'text'],
            ['gid' => 'user_service_expired', 'name' => 'Users paid service expired', 'vars' => ['user', 'name'], 'content_type' => 'text'],
        ],
        'notifications' => [
            ['gid' => 'user_package_enabled', 'template' => 'user_package_enabled', 'send_type' => 'simple'],
            ['gid' => 'user_service_enabled', 'template' => 'user_service_enabled', 'send_type' => 'simple'],
            ['gid' => 'user_service_expired', 'template' => 'user_service_expired', 'send_type' => 'simple'],
        ],
    ],
    'dynamic_blocks' => [
        [
            'gid' => 'featured_companies_block',
            'module' => 'users_services',
            'model' => 'Users_services_model',
            'method' => 'dynamicBlocksFeaturedCompanies',
            'params' => ['count' => ['gid' => 'count', 'type' => 'int', 'default' => 8],],
            'views' => [
                ['gid' => 'gallery_middle'],
            ],
        ],
        [
            'gid' => 'featured_agents_block',
            'module' => 'users_services',
            'model' => 'Users_services_model',
            'method' => 'dynamicBlocksFeaturedAgents',
            'params' => ['count' => ['gid' => 'count', 'type' => 'int', 'default' => 8],],
            'views' => [
                ['gid' => 'gallery_middle'],
            ],
            'presets' => [
                [
                    'gid_preset' => 'agency',
                    'gid_area' => 'index-page',
                    'params' => ['count' => 2],
                    'view_str' => 'gallery_middle',
                    'width' => 50,
                    'cache_time' => '600',
                    'sorter' => 4,
                ],
            ],
        ],
    ],
    'cronjob' => [
        [
            'name' => 'Update users services',
            'module' => 'users_services',
            'model' => 'Users_services_model',
            'method' => 'update_services',
            'cron_tab' => '*/10 * * * *',
            'status' => '1',
        ],
        [
            'name' => 'Users featured section clean',
            'module' => 'users_services',
            'model' => 'Users_services_model',
            'method' => 'service_featured_cron',
            'cron_tab' => '0 * * * *',
            'status' => '1',
        ],
        [
            'name' => 'Users show logo section clean',
            'module' => 'users_services',
            'model' => 'Users_services_model',
            'method' => 'service_show_logo_cron',
            'cron_tab' => '0 * * * *',
            'status' => '1',
        ],
    ],
    'seo' => [
        'module_gid' => 'users_services',
        'model_name' => 'Users_services_model',
        'get_settings_method' => 'get_seo_settings',
        'get_rewrite_vars_method' => 'request_seo_rewrite',
        'get_sitemap_urls_method' => 'get_sitemap_xml_urls',
    ],
    'seo_links' => [
        [
            'controller' => 'user',
            'module' => 'users_settings',
            'method' => 'index',
            'data' => [
                'noindex' => 1,
                'title' => '',
                'keyword' => '',
                'description' => '',
                'header' => '',
                'og_title' => '',
                'og_type' => '',
                'og_descrtiption' => '',
                'url_template' => '[text:buy-][tpl:1:service_gid:literal:none][text:-service]',
            ],
        ],
        [
            'controller' => 'user',
            'module' => 'users_settings',
            'method' => 'my_services',
            'data' => [
                'noindex' => 1,
                'title' => '',
                'keyword' => '',
                'description' => '',
                'header' => '',
                'og_title' => '',
                'og_type' => '',
                'og_descrtiption' => '',
                'url_template' => '[text:my-services]',
            ],
        ],
    ],
];
